<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'dh';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 引入和实例化订单功能
include_once (ROOT_PATH . 'include/dh.class.php');
$dou_dh = new Dh();

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 售后列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['dh']);
 
    // 生成筛选条件
    $field = array('dh_sn', 'phone', 'contact');
    foreach ($field as $value) {
        $v['value'] = $value;
        $v['name'] = $_LANG['dh_' . $value];
        $v['cur'] = ($value == $_REQUEST['key']) ? true : false;
        $key[] = $v;
    }

    // 筛选关键词
    $keyword = isset($_REQUEST['keyword']) ? trim($_REQUEST['keyword']) : '';
    if ($keyword)
        $where = " WHERE $_REQUEST[key] LIKE '%$keyword%'";
    
    // 把第一个AND替换成WHERE
    $where = $_SESSION['where'] = $dou->where($where);
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('dh') . $where . " ORDER BY dh_id DESC";
 
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 25, $page, $dou->param($page_url), $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        // 会员信息
        $user = $dou->get_row('user', 'user_id, user_sn, email', "user_id = '$row[user_id]'");
        $user['username'] = $_PARAM['login_mode'] == 'email' ? $user['email'] : $user['telphone'];
        
        $dh_list[] = array (
                "dh_id" => $row['dh_id'],
                "dh_sn" => $row['dh_sn'],
                "user" => $user,
                "order_amount" => $row['order_amount'],
                "order_amount_format" => $dou->price_format($row['order_amount']),
                "contact" => $row['contact'],
                "phone" => $row['phone'],
                "address" => $row['address'],
                "remark" => $row['remark'],
                "status" => $dou->data_lang_format('dh_status_', $row['status']),
                "add_time" => date("Y-m-d H:i:s", $row['add_time'])
                
        );
    }
    
    // 赋值给模板
    $smarty->assign('key', $key);
    $smarty->assign('keyword', $keyword);
    $smarty->assign('dh_list', $dh_list);
    
    $smarty->display('dh.htm');
} 

/**
 * +----------------------------------------------------------
 * 售后编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'view') {
    $smarty->assign('ur_here', $_LANG['dh_view']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['dh_list'],
            'href' => 'dh.php' 
    ));
    
    // 验证并获取合法的ID
    $dh_id = $check->is_number($_REQUEST['dh_id']) ? $_REQUEST['dh_id'] : '';
    
    // 格式化服务单信息
    $dh = $dou->get_row('dh', '*', "dh_id = '$dh_id'");
    $dh['order_amount_format'] = $dou->price_format($dh['order_amount']);
    $dh['is_handle'] = $dh['status'] ? true : false; // 是否可以操作售后
    $dh['status'] = $dou->data_lang_format('dh_status_', $dh['status']);
    $dh['add_time'] = date("Y-m-d H:i:s", $dh['add_time']);
 
    // 订单信息
    $dh['user'] = $dou->get_row('user', 'user_id, user_sn, email', "user_id = '$dh[user_id]'");
    $dh['user']['username'] = $_PARAM['login_mode'] == 'email' ? $dh['user']['email'] : $dh['user']['telphone'];
 
    // 退货商品信息
    $dh['item_list'] = $dou_dh->get_item_list($dh['dh_id']);
    $dh_item = $GLOBALS['dou_dh']->excel_dh_item($dh['dh_id']);
    
    // 强制解锁
    $unlock = $check->is_letter($_REQUEST['unlock']) ? $_REQUEST['unlock'] : '';
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('dh', $dh);
    $smarty->assign('unlock', $unlock);
    
    $smarty->display('dh.htm');
}

/**
 * +----------------------------------------------------------
 * 售后处理
 * +----------------------------------------------------------
 */
elseif ($rec == 'handle') {
    // 验证并获取合法的ID
    $dh_id = $check->is_number($_REQUEST['dh_id']) ? $_REQUEST['dh_id'] : '';
    $unlock = $check->is_letter($_REQUEST['unlock']) ? $_REQUEST['unlock'] : '';
 
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
 
    // 售后信息
    $dh = $dou->get_row('dh', '*', "dh_id = '$dh_id'");
    if ($dh['status'] == 1 && !$unlock) // 强制解锁状态可以重复修改售后信息
        $dou->dou_msg($_LANG['dh_handle_wrong'], 'dh.php?rec=view&dh_id=' . $dh_id);
 
    // 格式化数据
    $action_time = time();
 
    // 订单处理
    $dou->query("UPDATE " . $dou->table('dh') . " SET remark = '$_POST[remark]', action_time = '$action_time', `status` = '1' WHERE dh_id = '$dh_id'");
    
    $dou->dou_header('dh.php?rec=view&dh_id=' . $dh_id);
}

/**
 * +----------------------------------------------------------
 * 批量操作选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'action') {
    // 判断是否安装会员导出功能
    if (file_exists($excel_file = ROOT_PATH . ADMIN_PATH . '/include/phpexcel/excel.class.php')) {
        include_once($excel_file);
        $excel = new Excel();
    }

    if (is_array($_POST['checkbox'])) {
        if ($_POST['action'] == 'cancel') { // 订单取消
            $dou_dh->cancel($_POST['checkbox']);
            $dou->dou_msg($_LANG['dh_cancel_success'], 'dh.php');
        } elseif ($_POST['action'] == 'excel') { // 导出所选会员
		          $excel->export_excel('dh', excel_dh_list($_POST['checkbox']));
        } else {
            $dou->dou_msg($_LANG['select_empty']);
        }
    } else {
        if ($_POST['action'] == 'excel_all') { // 导出所有
		          $excel->export_excel('dh', excel_dh_list());
            exit;
        }
        
        $dou->dou_msg($_LANG['select_empty']);
    }
}

/**
 * +----------------------------------------------------------
 * 导出的订单数据
 * +----------------------------------------------------------
 * $checkbox 所选的订单条目
 * +----------------------------------------------------------
 */
function excel_dh_list($checkbox = '', $where = '') {
    // 需要导出的字段
    $field = array('dh_sn', 'item_list', 'item_number', 'contact', 'phone', 'address', 'remark', 'status');
    
    // 导出的字段名称
    foreach ((array) $field as $value) {
        $excel_list['head'][] = $GLOBALS['_LANG']['dh_' . $value];
    }
    
    // 导出列表
    if ($checkbox) {
        $where = " WHERE dh_id IN (" . implode(',', $checkbox) . ")";
    } elseif($where) {
        $where = $where;
    } else {
        $where = $_SESSION['where'];
    }
    
    $sql = "SELECT * FROM " . $GLOBALS['dou']->table('dh') . $where . " ORDER BY dh_id DESC";
    $query = $GLOBALS['dou']->query($sql);
    while ($dh = $GLOBALS['dou']->fetch_array($query)) {
        // 格式化数据
        $dh_item = $GLOBALS['dou_dh']->excel_dh_item($dh['dh_id']);
        $dh['item_list'] = $dh_item['list'];
        $dh['item_number'] = $dh_item['number'];
        $dh['status'] = $GLOBALS['_LANG']['dh_status_' . $dh['status']];
        
        unset($list);
        foreach ((array) $field as $value) {
            $list[] = $dh[$value];
        }
        $excel_list['list'][] = $list;
    }
    
    return $excel_list;
}

?>