<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$sub = 'addcart|del|cart|address|success';
$subbox = array(
        "module" => 'dh',
        "sub" => $sub
);

if (!defined('REWRITE')) {
    $_CUR = 'dh';
    require (dirname(__FILE__) . '/include/init.php');
}
$smarty->assign('cur', $_CUR);
$smarty->assign('url', $_URL = $dou->dou_sub_url($subbox));

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 实例化售后功能
include_once (ROOT_PATH . 'include/dh.class.php');
$dou_dh = new Dh();

if (!$_OPEN['user'])
    $dou->dou_msg($_LANG['dh_no_install_user'], ROOT_URL);

// 验证是否登录
if (!is_array($_GLOBAL_USER)) {
    if ($rec == 'default') {
        $dou->dou_header($_URL['login']);
    } else {
        $data['nologin'] = true;
        echo json_encode($data);
        exit;
    }
}

// 当前会员ID
$user_id = $_GLOBAL_USER['user_id'];

// 赋值给模板-meta和title信息
$smarty->assign('keywords', $_CFG['site_keywords']);
$smarty->assign('description', $_CFG['site_description']);

// 赋值给模板-导航栏
$smarty->assign('nav_top_list', $dou->get_nav('top'));
$smarty->assign('nav_middle_list', $dou->get_nav('middle', 0, 'user', 0));
$smarty->assign('nav_bottom_list', $dou->get_nav('bottom'));

// 赋值给模板-数据
$smarty->assign('rec', $rec);


/**
 * +----------------------------------------------------------
 * 快速订货.列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    // 验证并获取合法的ID，如果不合法将其设定为-1
    $cat_id = $firewall->get_legal_id('product_category', $_REQUEST['cat_id'], NULL);
    
    if ($cat_id == -1) {
        $dou->dou_msg('page_wrong', HOME_URL);
    } elseif ($cat_id) {
        $where = ' WHERE cat_id IN (' . $cat_id . $dou->dou_child_id('product_category', $cat_id) . ')';
        $get = "?cat_id=$cat_id";
    }

    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('product') . $where . " ORDER BY sort ASC, id DESC";

    // 获取分页信息
    $page = $check->is_number($_REQUEST['page']) ? trim($_REQUEST['page']) : 1;
    $limit = $dou->pager($sql, 30, $page, $dou->rewrite_url('dh'), $get);

    /* 获取产品列表 */
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $url = $dou->rewrite_url('dh', $row['id']); // 获取经过伪静态产品链接
        $add_time = date("Y-m-d", $row['add_time']);

        // 如果描述不存在则自动从详细介绍中截取
        $description = $row['description'] ? $row['description'] : $dou->dou_substr($row['content'], 150, false);

        // 等级价格
        $level_price = $dou->sale('product', $row['id']); // 会员等级价格

        // 对应的分类信息
        $cate_info_row = $dou->get_row('product_category', 'cat_id, cat_name', "cat_id = '$row[cat_id]'");
        $cate_info_row['url'] = $dou->rewrite_url('product_category', $row['cat_id']);
     
        $cart_number = $dou->get_one("SELECT item_number FROM " . $dou->table('dh_item') . " WHERE user_id = '$_GLOBAL_USER[user_id]' AND item_id = '$row[id]' AND dh_id = '0'");

        $product_list[] = array (
                "id" => $row['id'],
                "cat_id" => $row['cat_id'],
                "name" => $row['name'],
                "defined" => $dou->format_defined($row['defined']),
                "price" => $row['price'] > 0 ? $dou->price_format($row['price']) : $_LANG['price_discuss'],
                "level_price" => $level_price ? $dou->price_format($level_price) : '',
                "thumb" => $dou->dou_file($row['image'], true),
                "image" => $dou->dou_file($row['image']),
                "defined" => $dou->format_defined($row['defined']),
                "cart_number" => $cart_number ? $cart_number : 0,
                "add_time" => $add_time,
                "description" => $description,
                "url" => $url,
                "cate_info" => $cate_info_row
        );
    }
    
    // 获取订单信息
    $consignee = $dou->get_row('user', 'contact, address, phone, postcode', "user_id = '" . $_GLOBAL_USER['user_id'] . "'");
    
    // 赋值给模板
    $smarty->assign('page_title', $dou->page_title('dh', 'dh'));
    $smarty->assign('ur_here', $dou->ur_here('dh', 'dh'));
    $smarty->assign('head', $_LANG['dh']);
    $smarty->assign('consignee', $consignee);
    $smarty->assign('product_category', $dou_dh->get_category('product_category', 0, $cat_id));
    $smarty->assign('product_list', $product_list);
    $smarty->assign('recommend_product', $dou->get_list('product', 'ALL', $_DISPLAY['home_product'], 'sort ASC'));

    $smarty->display('dh.dwt');
}

/**
 * +----------------------------------------------------------
 * 快速订货.加入购物车
 * +----------------------------------------------------------
 */
elseif ($rec == 'addcart') {
    // 获取问题ID
    if ($_POST['id'] && $check->is_number($_POST['id'])) {
        $item_id = $_POST['id'];
        $product = $dou->get_row('product', 'id, name, price', "id = '$item_id'");
    } else {
        $data['wrong'] = $_LANG['dh_wrong'];
        die(json_encode($data));
    }
    
    // 初始化数据
    $add_time = time();
 
    // 判断是否已经存在购物车中
    $item_row = $dou->get_row('dh_item', 'id, item_number', "user_id = '$_GLOBAL_USER[user_id]' AND item_id = '$item_id' AND dh_id = '0'");

    if ($item_row) { // 已经存在于购物车
        $item_number = $item_row['item_number'] + 1; // 获取商品数量，如果存在于购物车中，则要加上
        $dou->query("UPDATE " . $dou->table('dh_item') . " SET item_number = '$item_number' WHERE id = '$item_row[id]'");
    } else { // 新加入购物车
        $dou->query("INSERT INTO " . $dou->table('dh_item') . " (id, user_id, item_id, item_name, price)" . " VALUES (NULL, '$_GLOBAL_USER[user_id]', '$product[id]', '$product[name]', '$product[price]')");
    }
    
    echo json_encode($data);
}

/**
 * +----------------------------------------------------------
 * 快速订货.修改数量
 * +----------------------------------------------------------
 */
elseif ($rec == 'change') {
    $item_id = $check->is_number($_POST['id']) ? $_POST['id'] : exit;
    $item_number = $check->is_number($_POST['number']) ? $_POST['number'] : exit;
 
    if ($dou->value_exist('dh_item', 'item_id', $item_id, "user_id = '$_GLOBAL_USER[user_id]'")) { // 已经存在于购物车
        $dou->query("UPDATE " . $dou->table('dh_item') . " SET item_number = '$item_number' WHERE item_id = '$item_id' AND user_id = '$_GLOBAL_USER[user_id]' AND dh_id = '0'");
    }
    
    $data['msg'] = 'success';
    echo json_encode($data);
}

/**
 * +----------------------------------------------------------
 * 快速订货.删除商品
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    $item_id = $check->is_number($_POST['id']) ? $_POST['id'] : exit;
 
    if ($dou->value_exist('dh_item', 'item_id', $item_id, "user_id = '$_GLOBAL_USER[user_id]'")) { // 已经存在于购物车
        $dou->delete('dh_item', "item_id = '$item_id' AND user_id = '$_GLOBAL_USER[user_id]' AND dh_id = '0'");
    }
    
    $data['msg'] = 'success';
    echo json_encode($data);
}

/**
 * +----------------------------------------------------------
 * 快速订货.加入购物车
 * +----------------------------------------------------------
 */
elseif ($rec == 'cart') {
    $data['cart'] = $dou_dh->get_cart();
    
    echo json_encode($data);
}

/**
 * +----------------------------------------------------------
 * 完成订单操作，提交到数据库
 * +----------------------------------------------------------
 */
elseif ($rec == 'success') {
    // 判断是否为空
    $wrong = $check->fn_empty('dh', 'contact, phone, address');
 
    // 判断是否含有非法字符
    $wrong = $check->fn_illegal_char('dh', 'contact, phone, address');
 
    // AJAX验证表单
    if ($_REQUEST['do'] == 'callback') {
        if ($wrong) {
            foreach ($_POST as $key => $value) {
                $wrong_json[$key] = $wrong[$key];
            }
            echo json_encode($wrong_json);
        } else {
            echo json_encode('');
        }
        exit;
    }

    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format .= $wrong[$key] . '<br>';
        }
        $dou->dou_msg($wrong_format, $_URL['dh']);
    }

    // 验证是否登录
    if (!is_array($_GLOBAL_USER)) {
        $dou->dou_header($_URL['login']);
    }

    // 获取购物车信息
    $cart = $dou_dh->get_cart();
    
    // 检查购物车是否有商品
    if (!$cart['item_amount'])
        $dou->dou_msg($_LANG['dh_cart_empty'], $_URL['dh']);
 
    // 获取和格式化数据
    $dh_sn = $dou_dh->create_dh_sn();
    $add_time = time();
    $order_amount = $cart['item_amount'];
    
    // 安全处理用户输入信息
    $_POST = $firewall->dou_foreground($_POST);
    
    // 订单信息插入
    $dou->query("INSERT INTO " . $dou->table('dh') . " (dh_id, dh_sn, user_id, contact, phone, address, order_amount, add_time)" . " VALUES (NULL, '$dh_sn', '$_GLOBAL_USER[user_id]', '$_POST[contact]', '$_POST[phone]', '$_POST[address]', '$order_amount', '$add_time')");

    // 订单商品插入
    $dh_id = $dou->insert_id();
    $dou->query("UPDATE " . $dou->table('dh_item') . " SET dh_id = '$dh_id' WHERE user_id = '$_GLOBAL_USER[user_id]' AND dh_id = '0'");

    if ($_POST['update_user_information']) {
        $dou->query("UPDATE " . $dou->table('user') . " SET phone = '$_POST[phone]', contact = '$_POST[contact]', address = '$_POST[address]' WHERE user_id = '$_GLOBAL_USER[user_id]'");
    }
    
    $dou->dou_msg($_LANG['dh_success'], $_URL['dh']);
}

?>