<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
if (!defined('IN_DOUCO')) {
    die('Hacking attempt');
}
class Dh {
    /**
     * +----------------------------------------------------------
     * 生成唯一的退换货编号
     * +----------------------------------------------------------
     */
    function create_dh_sn() {
        // 随机生成订单号
        $user_sn = $GLOBALS['_GLOBAL_USER']['user_sn'];
        
        $dh_sn = date('ymdHis') . str_pad(mt_rand(1, 99), 2, '0', STR_PAD_LEFT) . $user_sn;

        return $dh_sn;
    }
 
    /**
     * +----------------------------------------------------------
     * 用户权限判断
     * +----------------------------------------------------------
     * $session_cart session储存的商品信息
     * +----------------------------------------------------------
     */
    function get_cart($user_id = '') {
        $user_id = $user_id ? $user_id : $GLOBALS['_GLOBAL_USER']['user_id'];
        $cart['list'] = array();
        
        /* 获取产品列表 */
        $query = $GLOBALS['dou']->query("SELECT * FROM " . $GLOBALS['dou']->table('dh_item') . " WHERE user_id = '$user_id' AND dh_id = '0' ORDER BY id DESC");
        while ($row = $GLOBALS['dou']->fetch_array($query)) {
            $item = $GLOBALS['dou']->get_row('product', '*', "id = '$row[item_id]'");
            
            // 价格
            $level_price = $GLOBALS['dou']->user_level_price($item['level_price'], $user_id); // 会员等级价格
            $price = $level_price ? $level_price : $item['price']; // 交易价格
             
            $url = $GLOBALS['dou']->rewrite_url('product', $item['id']);
            $subtotal = $price > 0 ? $GLOBALS['dou']->price_format($price * $row['item_number']) : $GLOBALS['_LANG']['price_discuss'];
            
            $cart['list'][] = array (
                    "id" => $item['id'],
                    "name" => $item['name'],
                    "price_normal" => $price,
                    "price" => $price > 0 ? $GLOBALS['dou']->price_format($price) : $GLOBALS['_LANG']['price_discuss'],
                    "url" => $url,
                    "thumb" => $GLOBALS['dou']->dou_file($item['image'], true),
                    "subtotal" => $subtotal,
                    "number" => $row['item_number']
            );
            
            // 商品总数量
            $cart['total'] += $row['item_number'];

            // 商品总金额
            $cart['item_amount'] += ($price * $row['item_number']);
            $cart['item_amount_format'] = $GLOBALS['dou']->price_format($cart['item_amount']);
        }
            
        return $cart;
    }
    
    /**
     * +----------------------------------------------------------
     * 获取有层次的栏目分类，有几层分类就创建几维数组
     * +----------------------------------------------------------
     * $table 数据表名
     * $parent_id 默认获取一级导航
     * $current_id 当前页面栏目ID
     * +----------------------------------------------------------
     */
    function get_category($table, $parent_id = 0, $current_id = '') {
        $category = array ();
        $data = $GLOBALS['dou']->fn_query("SELECT * FROM " . $GLOBALS['dou']->table($table) . " ORDER BY sort ASC, cat_id ASC");
        foreach ((array) $data as $value) {
            // $parent_id将在嵌套函数中随之变化
            if ($value['parent_id'] == $parent_id) {
                $value['url'] = $GLOBALS['dou']->param($GLOBALS['_URL']['dh'] . '&cat_id=' . $value['cat_id']);
                $value['icon'] = $GLOBALS['dou']->dou_file($value['icon']);
                $value['cur'] = $value['cat_id'] == $current_id ? true : false;
                
                foreach ($data as $child) {
                    // 筛选下级导航
                    if ($child['parent_id'] == $value['cat_id']) {
                        // 嵌套函数获取子分类
                        $value['child'] = $this->get_category($table, $value['cat_id'], $current_id);
                        break;
                    }
                }
                $category[] = $value;
            }
        }
        
        return $category;
    }
    
    /**
     * +----------------------------------------------------------
     * 清空会员购物车
     * +----------------------------------------------------------
     */
    function clear_cart($user_id = '') {
        if ($user_id = ($user_id ? $user_id : $GLOBALS['_GLOBAL_USER']['user_id']))
            $GLOBALS['dou']->query("DELETE FROM " . $GLOBALS['dou']->table('order_cart') . " WHERE user_id = '$user_id'");
    }

    /**
     * +----------------------------------------------------------
     * 获取订单商品
     * +----------------------------------------------------------
     * $order_id 订单编号
     * +----------------------------------------------------------
     */
    function get_item_list($dh_id) {
        /* 获取产品列表 */
        $query = $GLOBALS['dou']->query("SELECT * FROM " . $GLOBALS['dou']->table('dh_item') . " WHERE dh_id = '$dh_id' ORDER BY id DESC");
    
        while ($row = $GLOBALS['dou']->fetch_array($query)) {
            // 格式化价格
            $price = $GLOBALS['dou']->price_format($row['price']);
            $image = $GLOBALS['dou']->get_one("SELECT image FROM " . $GLOBALS['dou']->table('product') . " WHERE id = '$row[item_id]'");
            $url = $GLOBALS['dou']->rewrite_url('product', $row['item_id']);
            
            $item_list[] = array (
                    "item_id" => $row['item_id'],
                    "item_name" => $row['item_name'],
                    "thumb" => $GLOBALS['dou']->dou_file($image, true),
                    "url" => $url,
                    "item_number" => $row['item_number'],
                    "name" => $row['name'],
                    "price" => $GLOBALS['dou']->price_format($row['price'])
            );
        }
        
        return $item_list;
    }
 
    /**
     * +----------------------------------------------------------
     * 导出订单商品列表
     * +----------------------------------------------------------
     */
    function excel_dh_item($dh_id) {
        /* 获取产品列表 */
        $query = $GLOBALS['dou']->query("SELECT * FROM " . $GLOBALS['dou']->table('dh_item') . " WHERE dh_id = '$dh_id' ORDER BY id DESC");
        
        $dh_item['number'] = 0;
        $dh_item['list'] = array();
        while ($row = $GLOBALS['dou']->fetch_array($query)) {
            $list .= $row['item_name'] . ' * ' . $row['item_number'] . '  ';
        }
        
        $dh_item['number'] = $GLOBALS['dou']->get_one("SELECT SUM(item_number) FROM " . $GLOBALS['dou']->table('dh_item') . " WHERE dh_id = '$dh_id' ORDER BY id DESC");
        $dh_item['list'] = $list;
         
        return $dh_item;
    }
    
    /**
     * +----------------------------------------------------------
     * 批量取消订单
     * +----------------------------------------------------------
     */
    function cancel($checkbox = '') {
        foreach ((array)$checkbox as $dh_id) {
            $GLOBALS['dou']->query("UPDATE " . $GLOBALS['dou']->table('dh') . " SET status = '-1' WHERE dh_id = '$dh_id'");
        }
    }

    /**
     * +----------------------------------------------------------
     * 发送下单并付款成功通知邮件
     * +----------------------------------------------------------
     * $order_sn 订单编号
     * +----------------------------------------------------------
     */
    function send_order_success_email($order_sn) {
        // 订单成功邮件提醒
        $order = $GLOBALS['dou']->get_row('order', '*', "order_sn = '$order_sn'");
        $order['add_time'] = date("Y-m-d H:i:s", $order['add_time']);
        
        $title = $GLOBALS['_LANG']['order_success'] . '：' . $order['order_sn'];
        $body  = $GLOBALS['_LANG']['order_add_time'] . '：' . $order['add_time'] . '<br/>';
        $body .= $GLOBALS['_LANG']['order_sn'] . '：' . $order['order_sn'] . '<br/>';
        $body .= $GLOBALS['_LANG']['order_order_amount'] . '：' . $order['order_amount'] . '<br/>';
        $body .= $GLOBALS['_LANG']['order_status'] . '：' . $GLOBALS['_LANG']['order_status_' . $order['status']] . '<br/>';
        $body .= $GLOBALS['_LANG']['order_contact'] . '：' . $order['contact'] . '<br/>';
        $body .= $GLOBALS['_LANG']['order_telphone'] . '：' . $order['telphone'] . '<br/>';
        $body .= $GLOBALS['_LANG']['order_address'] . '：' . $order['address'];
        
        $GLOBALS['dou']->send_mail($GLOBALS['_CFG']['email'], $title, $body);
    }

}

?>