/**
 +----------------------------------------------------------
 * 初始化
 +----------------------------------------------------------
 */
$(document).ready(function() {
    $(".product-list .item").click(function() {
        var num = parseInt($(this).find('.cart-number').text());
        $(this).find('.cart-number').text(num + 1);
        if (!$(this).hasClass("c")) {
            $(this).addClass('c');
        }
    });
    
    // 设置初始高度
    size()
    $(window).resize(function(){
        size()
    });
});

function size() {
    // 设置初始高度
    if ($(window).width() > 992) {
        var orderH3 = $("#orderH3").outerHeight(true);

        $(".dh-left").height($(window).height());
        $("#orderList").height($(window).height() - orderH3);
    } else {
        $(".dh-left").height('auto');
        $("#orderList").height('auto');
    }
}

/**
 +----------------------------------------------------------
 * VUE
 +----------------------------------------------------------
 */
var vm = new Vue({
    el:'#dh',
    data:{
        cart:'',
        nologin:'',
        wrong:''
    },
    mounted: function (){
        // 载入购物车
        this.loadcart()
     
        this.initSwiper()

        //将Vue方法传到全局对象window中
        window.key = this.key;
        window.ask = this.ask;
    },
    methods:{
        // 加入购物车
        addcart:function(id) {
            this.$http.post(root_url + 'dh.php?rec=addcart',{id:id},{emulateJSON:true}).then(function(res){
                if (res.data.nologin) {
                    window.location.href = "user";
                }
                if (res.data.wrong) {
                    alert(res.data.wrong);
                }
             
                // 载入购物车
                this.loadcart()
            },function(res){
                console.log('失败')
            })
        },
        
        // 加载列表
        loadcart:function() {
            this.$http.post(root_url + 'dh.php?rec=cart',{},{emulateJSON:true}).then(function(res){
                if (res.data.nologin) {
                    window.location.href = "user";
                }
                if (res.data.wrong) {
                    alert(res.data.wrong);
                }
                
                if (res.data.cart) {
                    this.cart = res.data.cart;
                }
             
                this.initSwiper()
            },function(res){
                console.log('失败')
            })
        },
        
        // 加载列表
        initSwiper:function() {
            setTimeout(()=>{
            var swiper = new Swiper('.swiper-container', {
                direction: 'vertical',
                roundLengths : true, 
                slidesPerView: 'auto',
                freeMode: true,
                scrollbar: {
                  el: '.swiper-scrollbar',
                },
                mousewheel: true,
            });
            },300)
        },
        
        // 改变数量
        change:function(id, number) {
            var number = number == 0 ? 1 : number;
            this.$http.post(root_url + 'dh.php?rec=change',{id:id, number:number},{emulateJSON:true}).then(function(res){
                if (res.data.nologin) {
                    window.location.href = "user";
                }
                if (res.data.wrong) {
                    alert(res.data.wrong);
                }
             
                $("#p_" + id).find('.cart-number').text(number)
             
                // 载入购物车
                this.loadcart()
            },function(res){
                console.log('失败')
            })
        },
        
        // 删除
        del:function(id) {
            this.$http.post(root_url + 'dh.php?rec=del',{id:id},{emulateJSON:true}).then(function(res){
                console.log(res.data)
                
                if (res.data.nologin) {
                    window.location.href = "user";
                }
                if (res.data.wrong) {
                    alert(res.data.wrong);
                }
             
                $("#p_" + id).removeClass("c")
                $("#p_" + id).find('.cart-number').text(0)
             
                // 载入购物车
                this.loadcart()
            },function(res){
                console.log('失败')
            })
        },
        
        // 弹出信息
        innerHTML:function(e) {
            this.ask(e.target.innerHTML)
        },
    }
})

/**
 +----------------------------------------------------------
 * 刷新验证码
 +----------------------------------------------------------
 */
function refreshimage() {
    var cap = document.getElementById("vcode");
    cap.src = cap.src + '?';
}

/**
 +----------------------------------------------------------
 * 表单提交
 +----------------------------------------------------------
 */
function douSubmit(form_id, callback) {
    var callback = arguments[1] ? arguments[1] : 'json';
    var formParam = $("#"+form_id).serialize(); //序列化表格内容为字符串
    
    $.ajax({
        type: "POST",
        url: $("#"+form_id).attr("action")+'&do=callback',
        data: formParam,
        dataType: "json",
        success: function(form) {
            if (!form) {
                $("#"+form_id).submit();
            } else {
                for(var key in form) {
                    if (callback == 'alert') {
                        if (form[key]) {
                            alert(form[key]);
                            break;
                        }
                    } else {
                        $("#"+key).html(form[key]);
                    }
                }
            }
        },   
        error:function (data, status, e){   
          alert("error");   
        }
    });
}
